/*
This is not completely my code. It is a modification 
of code by the instructable: www.instructables.com/id/pot2/

nodemcu v1.0 via arduino ide

change line 64 with your alarm email address, subject and body text
change line 75 with your locations wifi name & password

*/

#ifdef __AVR__
#include <avr/power.h>
#endif
#define PIN            4 //D2 

#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <SPI.h>

#include <DHT.h>
#define DHTPIN 12   //D6
#define DHTTYPE DHT22
DHT dht(DHTPIN, DHTTYPE);
float humidity, temp_f; 

int sensor_light = 13;  //D7
int value_light;

const int buzzer = 14; //D5

int sensor_water = A0;  //A0 analog input
int value_water;

char auth[] = ""; //enter blynk auth token in between the quotes

#include <SimpleTimer.h>
SimpleTimer timer;

void temp_humid(){
  float h = dht.readHumidity();
  float t = dht.readTemperature();
  Blynk.virtualWrite(1, t);  			 //V1
  Blynk.virtualWrite(2, h);  			 //V2

  if(t<5)
  {
    Blynk.notify("It's getting kind of chilly over here");

    tone(buzzer, 200); // Sends sound signal
    delay(50);        // tenth of a sec
    noTone(buzzer);
  }
}

void water_light(){
  value_light = digitalRead(sensor_light);
  Blynk.virtualWrite(3, value_light);    //V3
  
  value_water = analogRead(sensor_water);
  Blynk.virtualWrite(4, value_water);    //V4
  if (value_water < 100) {
  Blynk.email("your_email@example.com", "Hello, yes", "I am thirsty, yes"); //enter your email address- the second parameter is the subject of the email, and the third is the content
  Blynk.notify("Yo bro, I'm thirsty"); 
   
  tone(buzzer, 200); // Sends sound signal
  delay(50);        // tenth of a sec
  noTone(buzzer);   
  }
}

void setup() {
  //Serial.begin(9600);  			  //delete serial comments when troubleshoot is necessary
  Blynk.begin(auth, "wifiName", "password");  //enter wifi name & password
  
  pinMode(buzzer, OUTPUT);
  
  pinMode(sensor_light, INPUT);
  
  //change to 43000000 for twice a day
  timer.setInterval(60000, water_light); //is at once a minute
  timer.setInterval(1000, temp_humid);  //for more than 3times/day, each time about 60seconds. wake up just to get readings from all sensors
}                   					//3 times, 20seconds apart. go to deep sleep, wake up8hrs later, do the same for 60seconds...

void loop() {
  Blynk.run();
  timer.run();
}
